         TITLE 'FIND 1ST MATCH OF (PARTIAL) KEY IN CHARACTER STRING '
***********************************************************************
*     FMATCH
***********************************************************************
         SPACE
*
*   REGISTER USAGE :
*
*   R2   -> PARAMETER LIST
*   R3   STRING ADDRESS
*   R4   STRING LENGTH
*   R5   KEY ADDRESS
*   R6   KEY LENGTH
*   R9   RESULT
*
*   LINKAGE :
*
*   DCL  FMATCH  ENTRY EXT RETURNS(BIN FIXED (15));
*   1)  K = FMATCH(STR,KEY);
*   2)  K = FMATCH(STR,KEY,CHAR);
*
         SPACE
FMATCH   CSECT
         INIT  FMATCH
         SPACE
         LR    R2,R1
         LA    R9,0
         MVI   SUPPRESS+1,C'*'
         SPACE
A100     EQU   *                       STRING
         TM    0(R2),X'80'             FIRST PARM THE LAST?
         BO    B100                    YES - SIGNAL ERROR
         L     R3,0(R2)                ADDR LOCATOR/DESCRIPTOR
         TM    6(R3),X'80'             VARYING STRING ?
         BZ    A110                    NO - BRANCH
         L     R3,0(R3)                ADDR DATA
         LH    R4,0(R3)                GET LENGTH FROM PREFIX
         LA    R3,2(R3)                RESET START
         B     A120
         SPACE
A110     EQU   *
         LH    R4,4(R3)                GET LENGTH FROM DESCRIPTOR
         L     R3,0(R3)                ADDR DATA
         SPACE
A120     EQU   *                       KEY
         LA    R2,4(R2)
         TM    0(R2),X'80'             SECOND PARM THE LAST?
         BO    B100                    YES - SIGNAL ERROR
         L     R5,0(R2)                ADDR LOCATOR/DESCRIPTOR
         TM    6(R5),X'80'             VARYING STRING ?
         BZ    A130                    NO - BRANCH
         L     R5,0(R5)                ADDR DATA
         LH    R6,0(R5)                GET LENGTH FROM PREFIX
         LA    R5,2(R5)                RESET START
         B     A140
         SPACE
A130     EQU   *
         LH    R6,4(R5)                GET LENGTH FROM DESCRIPTOR
         L     R5,0(R5)                ADDR DATA
A140     EQU   *                       SUPPRESS CHARACTER
         LA    R2,4(R2)
         TM    0(R2),X'80'             LAST PARM?
         BO    A180                    YES - SUPPRESS CHAR NOT PRES
         L     R7,0(R2)                ADDR LOCATOR/DESCRIPTOR
         TM    6(R7),X'80'             VARYING STRING ?
         BZ    A160                    NO - BRANCH
         L     R7,0(R7)                ADDR DATA
         LH    R8,0(R7)                GET LENGTH FROM PREFIX
         LA    R7,2(R7)                RESET START
         B     A170
         SPACE
A160     EQU   *
         LH    R8,4(R7)                GET LENGTH FROM DESCRIPTOR
         L     R7,0(R7)                ADDR DATA
A170     EQU   *
         C     R8,=F'1'
         BL    A180
         MVC   SUPPRESS+1(1),0(R7)
         SPACE
         LA    R2,4(R2)
         TM    0(R2),X'80'             LAST PARM?
         BNO   B100                    NO - ERROR
         SPACE
A180     EQU   *
         C     R6,=F'256'              CHECK KEY LENGTH
         BH    B100                    SIGNAL ERROR
         SPACE
         CR    R6,R4                   CHECK KEY LEN:STRING LEN
         BH    Z100                    KEY LONGER - NO FMATCH
         C     R6,=F'0'                ZERO LENGTH KEY?
         BE    Z100                    YES - GIVE UP
         SPACE
         LR    R7,R3                   GET STRING ADDRESS
         LR    R11,R4                  CALC MAX ITERATIONS
         SR    R11,R6
         A     R11,=F'1'
         SPACE
A200     EQU   *                       MAIN LOOP
         LR    R8,R5                   KEY START
         LR    R9,R7                   COMPARE START
         LR    R10,R6                  COMPARE ITERATIONS(KEY LENGTH)
         SPACE
A210     EQU   *                       COMPARE LOOP
SUPPRESS CLI   0(R8),C'*'              ALTERABLE INSTRUCTION
         BE    A220
         CLC   0(1,R9),0(R8)           COMPARE A CHAR PAIR
         BNE   A230                    UNEQUAL - BRANCH
A220     EQU   *
         LA    R8,1(R8)                INCR POINTERS
         LA    R9,1(R9)
         BCT   R10,A210                BRANCH BACK
         SPACE
         SR    R9,R3                   FOUND
         SR    R9,R6
         A     R9,=F'1'
         B     Z100
         SPACE
A230     EQU   *                       NO MATCH THIS ITERATION
         LA    R7,1(R7)                INCR POINTER
         BCT   R11,A200                BRANCH BACK
         SPACE
         LA    R9,0                    NOT FOUND
         B     Z100
         SPACE
B100     EQU   *                       SIGNAL ERROR
         LA    R1,ICB
         L     R15,120(R12)
         BALR  R14,R15
         SPACE
Z100     EQU   *                       SET RESULT
         L     R2,0(R2)
         STH   R9,0(R2)
         SPACE
         EXIT  RC=0
         EJECT
**********************************************************************
*   WORKAREAS
**********************************************************************
         SPACE
ICB      DS    0F
         DC    X'0C'
         DC    AL3(0)
         DC    5F'0'
         SPACE 2
         LTORG
         SPACE
         END
